﻿SystemOrganization addCategory: #'Janken-sumim'!

Magnitude subclass: #JankenHand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sumim'!

JankenHand subclass: #JankenChoki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sumim'!

!JankenChoki methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:02'!
name
	^#チョキ!]lang[(8 3)0,5! !

!JankenChoki methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:08'!
superior
	^JankenGu! !

JankenHand subclass: #JankenGu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sumim'!

!JankenGu methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:03'!
name
	^#グー!]lang[(8 2)0,5! !

!JankenGu methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:08'!
superior
	^JankenPa! !

!JankenHand class methodsFor: 'examples' stamp: 'sumim 8/12/2016 20:55'!
example
	"JankenHand example"
	| numOfPlayers availableHands |

	Transcript open.

	numOfPlayers := (UIManager default request: 'プレーヤー人数を入力してください:') asInteger.
	numOfPlayers ifNil: [^self].	  
	availableHands := JankenHand subclasses.

	[	| hands |

		hands := (1 to: numOfPlayers) collect: [:idx | availableHands atRandom new].
		hands doWithIndex: [:hand :idx |
				Transcript cr; show: ('プレーヤー{1}: {2}' format: {idx. hand}).
		].

		hands asSet size ~= 2
			ifTrue: [Transcript cr; show: '引き分けです']
			ifFalse: [
				| winner winnerIndics |
				winner := hands max.
				Transcript cr; show: 'プレーヤー'.
				winnerIndics := (1 to: hands size) select: [:idx | (hands at: idx) = winner].
				winnerIndics
					do: [:idx | Transcript show: idx]
					separatedBy: [Transcript show: ', '].
				Transcript show: 'の', winner printString, 'の勝ちです'
			].

		Transcript cr; endEntry.

		(UIManager default confirm: '続けますか？') ifFalse: [^self]

	] repeat!]lang[(129 16 246 5 96 6 96 5 206 1 24 5 68 6 30)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !

!JankenHand methodsFor: 'comparing' stamp: 'sumim 8/13/2016 17:36'!
< other
	^other class = self superior! !

!JankenHand methodsFor: 'comparing' stamp: 'sumim 8/13/2016 17:36'!
= other
	^other class = self class! !

!JankenHand methodsFor: 'comparing' stamp: 'sumim 8/12/2016 20:49'!
hash
	^self class name hash! !

!JankenHand methodsFor: 'accessing' stamp: 'sumim 8/12/2016 20:49'!
name
	self subclassResponsibility! !

!JankenHand methodsFor: 'printing' stamp: 'sumim 8/12/2016 21:02'!
printOn: stream
	stream nextPutAll: self name! !

!JankenHand methodsFor: 'accessing' stamp: 'sumim 8/13/2016 10:59'!
superior
	self subclassResponsibility! !

JankenHand subclass: #JankenPa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Janken-sumim'!

!JankenPa methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:03'!
name
	^#パー!]lang[(8 2)0,5! !

!JankenPa methodsFor: 'accessing' stamp: 'sumim 8/12/2016 21:08'!
superior
	^JankenChoki! !
